﻿local mod = RW:Boss("Corla, Herald of Twilight", "Party - Cataclysm", "Blackrock Caverns")
local L

mod.type = "party"

mod.BossIcon = [[Interface\ICONS\Achievement_Dungeon_BlackrockCaverns_Corla Herald of Twilight]]

---------------------------
-- Variables

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(39679)
	self:SetWin()
	
	self:RegisterAlert("wEvolution", self:Warning(87378))
	
	self:RegisterAlert("wShadowStrike", self:CastWarning(82362))
	self:RegisterAlert("tShadowStrike", self:CastTimer(3, 82362))
	
	self:RegisterAlert("wAdd", self:Warning(75608))
end

---------------------------
-- Locals
local EvoSpamm

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Evolution", 87378, 75697)
	self:Track("ShadowStrike", 82362, 87374)
	self:Track("Kneel", 75608)
	
	EvoSpamm = 0
end

function mod:Evolution(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		local amount = args.amount or 1
		local t = GetTime()
		if amount > 75 and t - EvoSpamm > 4 then
			self:Call("wEvolution", "Show")
			EvoSpamm = t
		end
	end
end

function mod:ShadowStrike(event, args)
	if event == "SPELL_CAST_START" then 
		self:Call("wShadowStrike", "Show")
		if self:IsHeroic() then
			self:Call("tShadowStrike", "Start", 2)
		else
			self:Call("tShadowStrike", "Start")
		end
	end
end

function mod:Kneel(event, args)
	if event == "SPELL_AURA_REMOVED" then
		self:Call("wAdd", "Show")
	end
end
